#ifndef __PRESET_H__
#define __PRESET_H__

#include "dsp/oscillator.h"
#include "dsp/filter.h"
#include "dsp/adsr.h"

struct Preset {
    typedef struct {
        uint8_t attack;
        uint8_t decay;
        uint8_t sustain;
        uint8_t release;
    } Envelope;

    uint8_t unison;

    uint8_t osc1Mode;
    uint8_t osc2Mode;
    uint8_t oscMix;
    uint8_t oscDetune;
    uint8_t osc2Pitch;

    uint8_t noiseMix;

    struct {
        uint8_t type;
        uint8_t slope;
        uint8_t freq;
        uint8_t Q;
    } filter;

    Envelope ampEnv;
    Envelope modEnv;

    uint8_t modEnvFltGain;
    uint8_t keyTrack;
    uint8_t lfoFreq;
    uint8_t lfoPitchMod;
    uint8_t lfoFltMod;

    uint8_t reverb;
};

extern const Preset DEFAULT_PRESET;

#endif