#include <cmath>

#include "dsp/reverb.h"

Reverb::Reverb() {
    size_t interval = REVERB_FRAMES / REVERB_TAPS - 4096 / REVERB_TAPS;
    for(size_t tap = 0; tap < REVERB_TAPS; ++tap) {
        float gain = exp2f(-8.f + 8.f * tap / (REVERB_TAPS - 1));
        taps[tap] = {
            .lp = tap * interval + (rand() % interval),
            .rp = tap * interval + (rand() % interval),
            .lg = (rand() > RAND_MAX / 2 ? 1 : -1) * gain,
            .rg = (rand() > RAND_MAX / 2 ? 1 : -1) * gain
        };
    }
}
